var gLeftTime=2;
var abURI=null;
var ioService=Components.classes["@mozilla.org/network/io-service;1"]
               .getService(Components.interfaces.nsIIOService);

var mabFiles;
var mabName;
var mabFile;
var warn=0;

var strings;

//TODO: welche Addressbcher sind auf dem Server zu finden!?
function download()
{
  strings = document.getElementById("strings");
  mabFiles=syncedAddressbooks();
  var synctype;
  try{ synctype = pref.getCharPref( "extensions.addressbookssync.synctype" ); }
    catch(e){ synctype = 'none'; }

  if (synctype=='local') {
    var localdir=pref.getCharPref( "extensions.addressbookssync.localpath" )
    if (localdir) {
      var dir = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
      dir.initWithPath( localdir );
      for (var i = 0; i < mabFiles.length; i++) {
        var mabFile=mabFiles[i];
        var mabName=getAddressBook(mabFile).directoryProperties.description;
        if (loadMabFile(false, mabName, mabFile, dir))
          statustxt("\n"+mabName+': '+strings.getString('ok'));
        else
          statustxt("\n"+mabName+': '+strings.getString('failed'));
      }
    }
    killMe();
  } else if (synctype=='remote') {
    abURI=getSyncURI();
    setTimeout(getData, 0);
  } else {
    killMe();
  }
}

function getData()
{
  mabFile=mabFiles.pop();
  if (!mabFile) {
    if (!warn) {
gLifeTime=5;//for debug
      killMe();
    }
    return;
  }
  mabName=getAddressBook(mabFile).directoryProperties.description;

//    MabFileName = mabName.replace( /\s|\./g, "_" );
//TODO: UTF8
  var remoteFileName = mabName+".mab";

  var mabURI=abURI+remoteFileName;
  var URI=ioService.newURI(mabURI,this.charset,null);

  statustxt("\ndownload "+mabName+"..");

  if(gBookmarksSynchronizerDownloadService.start(URI, downloadCallback))
    statustxt("."); //"request"
  else
    downloadCallback("done",-1);
}

function downloadCallback(aStatus,aError)
{
  if(aStatus != "done" && aError==0)
    return;

  var milisec=1000;

  switch(aError){
  case -2:
    milisec=0;
    return;
    break;
  case 0:
    var processtime=document.getElementById("processtime");
   var time=gBookmarksSynchronizerDownloadService.time;
    processtime.value=gBookmarksSynchronizerDownloadService.length.toString()
                      +" bytes  "+(time/1000).toString() + " sec  ";
    var start=new Date();
    statustxt("."); //"process"
    try{
      var abData=gBookmarksSynchronizerDownloadService.data;
      //Data must start with: // <!-- <mdb:mork:z v="1.4"/> --> otherwise its an HTML error page
      if (abData.substr( 0, 19 )=='// <!-- <mdb:mork:z') {
          // I found no way to say FF to reread the Addressbookfile. So i delete and recreate
          // the addressbook which does not work for pab(=abook) and cab(=history)
        deleteAddressBook( mabName, mabFile ); // NOP for 'history' und 'pab'!
        writeMabData(mabFile, true, abData);
        createAddressBook( mabName, mabFile );
        var end=new Date();
        processtime.value += ((end.getTime() - start.getTime())/1000).toString()+" sec";
        statustxt(strings.getString('ok'));
      } else {
        statustxt(strings.getString('failed'));
        warn=1;
     }
      getData();  // next addressbook
    }catch(e){
      if(e && e.toString().match(/^absync\:(.+)$/))
        statustxt(RegExp.$1);
      milisec=2000;
   }
    break;
  default:
    var error=errorstr(aError);
    statustxt(error);
    break;
  }
//  setTimeout(close, milisec);
}

function cancelDownload()
{
  gBookmarksSynchronizerDownloadService.cancel();
  killMe();
}

function killMe()
{
  if(gLeftTime>0)
  {
    gLeftTime--;
    setTimeout(killMe,1000);
  }
  else setTimeout(close,0);
}

function statustxt(aStatus)
{
  document.getElementById("status").value += aStatus;
}

